// **********************************************************************
// PUCRS/FACIN
// COMPUTAO GRFICA
//
// **********************************************************************
//
// Basico2D.cpp  
//
// Programa mnimo em OpenGL
//
//		- para compilar no Visual C ou Visual Studio acrescente as seguintes
//        bibliotecas:
//					 opengl32.lib glu32.lib glaux.lib glut32.lib 
//
//		- para compilar no DEVCPP (ou no g++) acrescente as seguintes
//        bibliotecas:
//		      -lopengl32 -lglut32 -lglu32 -lglaux 
//

//	Marcio Serolli Pinho
//	12/08/2003
//  pinho@inf.pucrs.br	
// **********************************************************************
#include <stdio.h>
#include <math.h>

#include <windows.h>

#include <GL\gl.h>
#include "glaux.h"
#include "glut.h"

// **********************************************************************
//  void init(void)
//		Inicializa os parmetros globais de OpenGL
//
// **********************************************************************
void init(void)
{
	glClearColor(0.0f, 0.0f, 1.0f, 1.0f); // Fundo de tela preto
}

// **********************************************************************
//  void reshape( int w, int h )
//		trata o redimensionamento da janela OpenGL
//
// **********************************************************************
void reshape( int w, int h )
{

	// Reset the coordinate system before modifying
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	// Set the viewport to be the entire window
    glViewport(0, 0, w, h);
	gluOrtho2D(-10,10,-10,10);

	// Set the clipping volume
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	glClearColor(0,1,0,1);
}
// **********************************************************************
//  void display( void )
//
//
// **********************************************************************
void display( void )
{

	glClear(GL_COLOR_BUFFER_BIT);

	glMatrixMode(GL_MODELVIEW);
	// <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
	// coloque aqui as chamadas das rotinas que desenha os objetos
	glColor3f(1,0,0);
	glBegin(GL_LINES);
	  glVertex2f(0,0);
	  glVertex2f(5,5);
	glEnd();
	
	glLineWidth(3);
	glColor3f(0,0,1);
	glBegin(GL_LINES);
	  glVertex2f(5,0);
	  glVertex2f(5,-5);
	glEnd();

	glutSwapBuffers();
}


// **********************************************************************
//  void keyboard ( unsigned char key, int x, int y )
//
//
// **********************************************************************
void keyboard ( unsigned char key, int x, int y )  
{
	int i,j;

	unsigned char r,g,b;

	switch ( key ) 
	{
		case 27:        // Termina o programa qdo
			exit ( 0 );   // a tecla ESC for pressionada
			break; 

		case 'a':
            //
            glutPostRedisplay(); 
		default:        
			break;
	}
}

// **********************************************************************
//  void arrow_keys ( int a_keys, int x, int y )  
//
//
// **********************************************************************
void arrow_keys ( int a_keys, int x, int y )  
{
	switch ( a_keys ) 
	{
		case GLUT_KEY_UP:       // When Up Arrow Is Pressed...
			glutFullScreen ( ); // Go Into Full Screen Mode
			break;
	    case GLUT_KEY_DOWN:     // When Down Arrow Is Pressed...
			glutInitWindowSize  ( 700, 500 ); 
			break;
		default:
			break;
	}
}

// **********************************************************************
//  void main ( int argc, char** argv )
//
//
// **********************************************************************
int main ( int argc, char** argv )   
{
	glutInit            ( &argc, argv ); 
	glutInitDisplayMode (GLUT_DOUBLE | GLUT_DEPTH | GLUT_RGB );
	glutInitWindowPosition (0,0);
	glutInitWindowSize  ( 500, 500 ); 
	glutCreateWindow    ( "Exemplo Bsico de OpenGL" ); 
		
	init ();
//	glutFullScreen();
	
	glutDisplayFunc ( display );  
	glutReshapeFunc ( reshape );
	glutKeyboardFunc ( keyboard );
	glutSpecialFunc ( arrow_keys );
	//glutIdleFunc ( display );

	glutMainLoop ( );          
	return 0;
}


